<template>
<div class="wrapper wrapper-content animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="ibox float-e-margins">
        <div class="ibox-title">
            <h5>Unit Of Measure</h5>
            <div class="ibox-tools">
                <a class="btn btn-primary btn-xs" @click="modal_show()">
                    Add Unit Of Measure
                </a>
                <a @click="load_unit_of_measure()">
                    <i class="fa fa-refresh"></i>
                </a>
          </div>
        </div>
        <!-- /.ibox-titel -->
        
        <div class="ibox-content">
            <!-- Search and filter form -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="pull-left form-inline">
                        <label>Show 
                            <input type="number" v-model="show_row" class="form-control input-sm" 
                                    style="width:60px;" min="1" max="1000">
                        </label>


                        <label>&nbsp;&nbsp;Limit
                            <input type="number" v-model="limit" class="form-control input-sm" 
                                    style="width:70px;" min="1" max="1000">
                        </label>
                    </div>

                    <div class="pull-right form-inline">
                        <label>Search:
                            <input v-model="search_key" class="form-control input-sm">
                        </label>&nbsp;
                    </div>
                </div>
            </div>
            <!-- /.row -->
          
            <div class="row" v-if="unit_of_measures.total">
                <div class="col-lg-12">
                    <div>
                        <div>
                            <p class="pull-left" style="margin-top: 7px;">
                                Showing  {{ unit_of_measures.from }} to  {{ unit_of_measures.to }}  of  {{ unit_of_measures.total }} entries.
                            </p>
                        </div>
                        <div class="table_pagination">
                            <div class="btn-group pull-right pagination pagination-sm no-margin" style="margin:-0px;">
                        
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !unit_of_measures.prev_page_url }" 
                                    @click=" gen_uri( unit_of_measures.prev_page_url )"
                                >
                                    <span>Prev</span>
                                </a>  
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !unit_of_measures.first_page_url }" 
                                    @click=" gen_uri( unit_of_measures.first_page_url )">
                                    <span>First</span>
                                </a>
                                <a class="btn btn-white btn-sm disabled"><span>...</span></a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !unit_of_measures.last_page_url }" 
                                    @click=" gen_uri(unit_of_measures.last_page_url)">
                                <span>Last</span>
                                </a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !unit_of_measures.next_page_url }" 
                                    @click=" gen_uri( unit_of_measures.next_page_url )"
                                >
                                <span>Next</span>
                                </a>
                            </div>
                        </div>        
                    </div>
                </div>
            </div>
            <!-- /.row -->

            <!-- Table -->
            <div class="table-responsive">
                <table class="table">
                    <thead>
                        <tr>
                            <th class="text-center">#</th>
                            <th>Code</th>
                            <th>Base Qty</th>
                            <th>Base Unit</th>
                            <th>Equal Qty</th>
                            <th>Equal Unit</th>
                            <th>&nbsp;</th>
                        </tr>
                    </thead>
                    <tbody v-if="loading">
                        <tr>
                            <td colspan="7">
                                <spinner></spinner>
                            </td>
                        </tr>
                    </tbody>
                    <tbody  v-else-if="unit_of_measures.data.length">
                        <unit-of-measure-table v-for="(unit_of_measure, row) in unit_of_measures.data" 
                                    :key="unit_of_measure.id" 
                                    :unit_of_measure="unit_of_measure" 
                                    :row="row"
                                    v-on:edit="modal_show"
                                    v-on:delete="unit_of_measure_delete"
                        >
                        </unit-of-measure-table>
                    </tbody>
                    <tbody v-else>
                        <tr>
                            <td colspan="7" class="text-center">
                                No Result!
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <!-- /.table-responsive -->
        </div>
        <!-- /.ibox-content -->
      </div>
      <!-- /.ibox float-e-margins -->
    </div>
    <!-- /.col-lg-12 -->
  </div>
  <!-- /.row -->

  <unit-of-measure-modal v-on:save="unit_of_measure_save" v-bind:modal="modal">
  </unit-of-measure-modal>
</div>  
<!-- /.wrapper wrapper-content animated fadeInRight -->
</template>

<script>
import axios from 'axios'
import Table from './Table.vue'
import Modal from './Modal.vue'
import Spinner from '../../other/Spinner.vue'
import appService from '../../../app.service.js'

export default {
    components: {
        'unit-of-measure-modal': Modal,
        'unit-of-measure-table': Table,
        'spinner': Spinner
    },
    data () {
        return {
            loading: false,
            search_key: '',
            show_row: 10,
            limit: 100,
            uri: '',
            unit_of_measures: [],
            modal: { 
                pause_save: false,
                errors: '',
                data: {
                    code: '',
                    base_qty: '',
                    base_unit: '',
                    equal_qty: '',
                    equal_unit: '',
                    id: ''
                }
            },
        }
    },
    methods: {
        load_unit_of_measure () {
            this.loading = true
            let uri = this.uri
            axios.get(uri).then(response => {
                this.unit_of_measures = response.data.unit_of_measures
                this.loading = false
            }).catch(response => {
                reject(response.status)
                this.loading = false
            })
        },
        gen_uri (qry_page = '') {
            let query = {
                base: 'unit-of-measure',
                page: qry_page.substr(1),
                show_row: this.show_row,
                limit: this.limit,
                search_key: this.search_key,
            }
            this.uri = appService.crud.generate_url( query ) 
            this.$router.push( this.uri )
        },
        modal_show( row_data ) {
            this.modal.errors = ''

            if(row_data) {
                this.modal.data = {
                    code: row_data.code,
                    base_qty: row_data.base_qty,
                    base_unit: row_data.base_unit,
                    equal_qty: row_data.equal_qty,
                    equal_unit: row_data.equal_unit,
                    id: row_data.id,
                }
            }else{
                this.modal.data = {
                    code: '',
                    base_qty: '',
                    base_unit: '',
                    equal_qty: '',
                    equal_unit: '',
                    id: '',
                }
            }

            $('#unit_of_measure_modal').modal('show');
        },
        unit_of_measure_save( data ) {
            this.modal.pause_save = true
            if(!data.id) {
                this.unit_of_measure_store( data )
            }else{
                this.unit_of_measure_update( data )
            }
        },
        unit_of_measure_store( data ) {
            appService.crud.store( '/unit-of-measure', data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#unit_of_measure_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                    this.load_unit_of_measure()
                }
                this.modal.pause_save = false
            })
        },
        unit_of_measure_update( data ){
            appService.crud.update( `/unit-of-measure/${data.id}`, data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#unit_of_measure_modal').modal('hide')
                    toastr.success( response.message, 'Updated!' )
                    this.load_unit_of_measure()
                }
            })
            this.modal.pause_save = false
        },
        unit_of_measure_delete( id ){
            appService.crud.delete( `/unit-of-measure/${id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.load_unit_of_measure()
                }
            })
        },
    },  
    watch: {
        '$route' (to, from) {
            this.load_unit_of_measure()
        },
        show_row: function () {
            this.loading = true
            this.gen_uri()
        },
        limit: function () {
            this.loading = true
            this.gen_uri()
        },
        search_key: function () {
            this.loading = true
            setTimeout(() => {
                this.gen_uri()
            }, 1500)
        }
    },
    created () {
        this.gen_uri()
        this.load_unit_of_measure()
    }
}
</script>